// $Id: crc32.h 272 2008-07-18 14:00:58Z tb $

#ifndef CRC32_H
#define CRC32_H

#include <stdint.h>

namespace Enctain {
namespace internal {

/// Return the CRC32 of the bytes buf[0..len-1].
uint32_t crc32(const unsigned char *buf, unsigned int len);

/// Update a running crc32 with the bytes buf[0..len-1] and return the updated
/// crc32.
uint32_t update_crc32(uint32_t crc, const unsigned char *buf, unsigned int len);

} // namespace internal
} // namespace Enctain

#endif // CRC32_H
