// -*- C++ -*- generated by wxGlade 0.6.2 on Sun Feb 17 10:38:53 2008
// $Id: wquery.h 272 2008-07-18 14:00:58Z tb $

#include <wx/wx.h>
#include <wx/stopwatch.h>

#include "wpwtutor.h"

// begin wxGlade: ::dependencies
// end wxGlade

#ifndef WQUERY_H
#define WQUERY_H

// begin wxGlade: ::extracode
// end wxGlade

class WQueryPass : public wxDialog
{
public:
    // begin wxGlade: WQueryPass::ids
    enum {
        myID_PASSTEXT = wxID_HIGHEST + 1000,
        myID_GIVEUP = wxID_HIGHEST + 1002
    };
    // end wxGlade

    WQueryPass(struct PassEntry& passentry, wxWindow* parent, int id=wxID_ANY, const wxString& title=wxEmptyString, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style=wxDEFAULT_DIALOG_STYLE);

    /// Updated reference to currently asked password entry.
    struct PassEntry&	passentry;

    /// Number of wrong entries during this query
    int		mywrongs;

    /// Number of times revealed during this query
    int		myrevealed;

    /// Current Score calculated
    double	score;

    /// Score added for a wrong entry.
    static const int	score_wrong_add = 1;
    
    /// Score factor multiplied for a wrong password entry.
    static const double score_wrong_factor = 2.0;

    /// Score added for password revealing.
    static const int	score_reveal_add = 10;

    /// Score factor multiplied for password revealing.
    static const double	score_reveal_factor = 2.0;

    /// Write score into textctrl and add a comment
    void	UpdateScore();

    /// Stopwatch measuring how long this query is taking
    wxStopWatch	stopwatch;

private:
    // begin wxGlade: WQueryPass::methods
    void set_properties();
    void do_layout();
    // end wxGlade

protected:
    // begin wxGlade: WQueryPass::attributes
    wxStaticBox* sizer2_staticbox;
    wxTextCtrl* textctrlDescription;
    wxTextCtrl* textctrlPass;
    wxTextCtrl* textctrlCheck;
    wxTextCtrl* textctrlScore;
    wxStaticText* labelCorrect;
    wxTextCtrl* textctrlCorrect;
    wxButton* buttonOk;
    wxButton* buttonGiveUp;
    // end wxGlade

    DECLARE_EVENT_TABLE();

public:
    virtual void OnTextPassEnter(wxCommandEvent &event); // wxGlade: <event_handler>
    virtual void OnTextPassChange(wxCommandEvent &event); // wxGlade: <event_handler>
    virtual void OnButtonOK(wxCommandEvent &event); // wxGlade: <event_handler>
    virtual void OnButtonGiveUp(wxCommandEvent &event); // wxGlade: <event_handler>
}; // wxGlade: end class

#endif // WQUERY_H
